/*global define, CKEDITOR, setTimeout*/
/*jslint regexp: true, unparam: true*/
define([
    'testsuite/qunit',
    'jquery',
    'ep/ui/editor',
    'testsuite/qunit-fixture!ckeditor/plugins/eplineheight/plugin-test',

    '$ready!'
    ], function (QUnit, $, ep, fixture) {
    'use strict';

    QUnit.module("ckeditor/plugins/eplistgroup", {
        teardown: fixture.destroy
    });

    QUnit.fixtureVar = fixture;

    function selectElementById(id, editorInstance) {
        editorInstance.getSelection().selectElement(editorInstance.document.getById(id));
        return;
    }

    setTimeout(function () {

        QUnit.fixtureVar.init();


        QUnit.asyncTest("basic eplineheight plugin tests", function () {
            // Instantiate CKE.
            ep('#uieditor_ckeditortestinstance_test1').uiEditor({
                    'name' : 'ckeditortestinstance_test1'
                });

            setTimeout(function () {
                var editorId = 'uieditor_ckeditortestinstance_test1',
                    editorClass = 'cke_1',
                    editorInstance = CKEDITOR.instances.uieditor_ckeditortestinstance_test1,
                    menuEntries;

                // Reset CKE data.
                editorInstance.setData('');
                // Check if eplineheight button exists.
                QUnit.equal(
                    $('.' + editorClass + ' .cke_button__eplineheight').length,
                    1,
                    'the necessary eplineheight button exists'
                );
                // Open submenu.
                $('.' + editorClass + ' .cke_button__eplineheight').trigger('click');

                setTimeout(function () {

                    QUnit.equal(
                        $('iframe.cke_panel_frame').length,
                        1,
                        'submenu is initialized'
                    );
                    QUnit.equal(
                        $('iframe.cke_panel_frame').is(':visible'),
                        true,
                        'submenu is open'
                    );

                    // Get all menu entries.
                    menuEntries = $('iframe.cke_panel_frame').contents().find('span.cke_menuitem');
                    QUnit.equal(
                        menuEntries.length,
                        6,
                        'submenu contains 6 entries'
                    );

                    // Insert a p-tag foreach menu entry.
                    menuEntries.each(function (index) {
                        editorInstance.insertHtml('<p id="id_' + index + '">' + $(this).find('a').text() + '</p><br />');
                    });

                    setTimeout(function () {
                        // Perform listformattings on p-tags.
                        menuEntries.each(function (index) {
                            selectElementById('id_' + index, editorInstance);
                            menuEntries.eq(index).find('a').trigger('click');
                        });

                        // Close submenu.
                        editorInstance.focus();

                        setTimeout(function () {
                            QUnit.equal(
                                $('iframe.cke_panel_frame').is(':visible'),
                                false,
                                'submenu is closed'
                            );

                            setTimeout(function () {
                                var data = editorInstance.getData(),
                                    fragment = $("<div />"),
                                    pTags = $(fragment).html(data).children('p[id^="id_"]'),
                                    lineHeights = [75, 100, 125, 150, 200, 300];

                                QUnit.ok(
                                    pTags.length === 6,
                                    'a p-Tag for every lineheight exist.'
                                );
                                pTags.each(function (index) {
                                    QUnit.ok(
                                        $(this).hasClass('line-height-' + lineHeights[index]),
                                        'p-Tag with class "line-height-' + lineHeights[index] + '".'
                                    );
                                });

                                QUnit.start();
                            }, 200);
                        }, 200);
                    }, 500);

                }, 500);
            }, 3000);
        });
    }, 500);
});